unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppGuide, PropSaveMain, StdCtrls, Menus, Buttons, ComCtrls,
  ToolWin, ExtCtrls, ImgList;

type
  TMain = class(TForm)
    AppGuideInterface1: TAppGuideInterface;
    AppGuide1: TAppGuide;
    PropSaveFile1: TPropSaveFile;
    PropSaveMain1: TPropSaveMain;
    MainMenu1: TMainMenu;
    mnFile: TMenuItem;
    mnShow: TMenuItem;
    mnDlg1: TMenuItem;
    ToolBar1: TToolBar;
    tbBold: TToolButton;
    tbItalic: TToolButton;
    mnAutoShowGuide: TMenuItem;
    mnExit: TMenuItem;
    ImageList1: TImageList;
    tbFontDlg: TToolButton;
    ToolButton1: TToolButton;
    Panel1: TPanel;
    Panel2: TPanel;
    btClose: TBitBtn;
    mEdit: TMemo;
    chWordWrap: TCheckBox;
    mnOpen: TMenuItem;
    N1: TMenuItem;
    btEdit: TBitBtn;
    FontDialog1: TFontDialog;
    mnHelp: TMenuItem;
    mnShowGuide: TMenuItem;
    mnDlg2: TMenuItem;
    mnDelSetting: TMenuItem;
    procedure mnAutoShowGuideClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure chWordWrapClick(Sender: TObject);
    procedure mnOpenClick(Sender: TObject);
    procedure tbBoldClick(Sender: TObject);
    procedure tbItalicClick(Sender: TObject);
    procedure tbFontDlgClick(Sender: TObject);
    procedure mnDlg1Click(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure mnShowGuideClick(Sender: TObject);
    procedure mnDelSettingClick(Sender: TObject);
    procedure mnDlg2Click(Sender: TObject);
    procedure mnExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

uses rtool, rdlg, f_dialog1, f_dialog2;

{$R *.dfm}

procedure TMain.FormShow(Sender: TObject);
begin
  AppGuideInterface1.UseGuide:=mnAutoShowGuide.Checked;
  chWordWrapClick(nil);
end;

procedure TMain.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMain.mnOpenClick(Sender: TObject);
begin
  mEdit.Lines.LoadFromFile('DemoGuide.txt');
end;

procedure TMain.mnDlg1Click(Sender: TObject);
begin
  // auto created dialog
  Dialog1.ShowModal;
  AppGuide1.ShowTopic;
end;

procedure TMain.mnDlg2Click(Sender: TObject);
begin
  // manual created dialog
  Application.CreateForm(TDialog2,Dialog2);
  Dialog2.ShowModal;
  Dialog2.Free;
  AppGuide1.ShowTopic;
end;

procedure TMain.mnShowGuideClick(Sender: TObject);
begin
  AppGuide1.AppGuideInterface.HelpTopic;
end;

procedure TMain.mnAutoShowGuideClick(Sender: TObject);
begin
  if not mnAutoShowGuide.Checked then AppGuideInterface1.CloseG;
  AppGuideInterface1.UseGuide:=mnAutoShowGuide.Checked;
end;

procedure TMain.tbBoldClick(Sender: TObject);
begin
  if tbBold.Down then mEdit.Font.Style:=mEdit.Font.Style+[fsBold]
                 else mEdit.Font.Style:=mEdit.Font.Style-[fsBold];
end;

procedure TMain.tbItalicClick(Sender: TObject);
begin
  if tbItalic.Down then mEdit.Font.Style:=mEdit.Font.Style+[fsItalic]
                   else mEdit.Font.Style:=mEdit.Font.Style-[fsItalic];
end;

procedure TMain.tbFontDlgClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(mEdit.Font);
  if FontDialog1.Execute then mEdit.Font.Assign(FontDialog1.Font);
end;

procedure TMain.chWordWrapClick(Sender: TObject);
begin
  mEdit.WordWrap:=chWordWrap.Checked;
  if mEdit.WordWrap then mEdit.ScrollBars:=ssVertical
                    else mEdit.ScrollBars:=ssBoth;
end;

procedure TMain.btEditClick(Sender: TObject);
begin
  RunFile('AppGuideEditor.exe',AppGuideInterface1.ContentFileName,'',SW_SHOW);
end;

procedure TMain.mnDelSettingClick(Sender: TObject);
begin
  AppGuideInterface1.EraseINI;
end;

procedure TMain.mnExitClick(Sender: TObject);
begin
  Close;
end;

end.
