unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, FormatLabel, IniFiles, Buttons,
  ImgList, ActnList, ActnMan, ToolWin, ActnCtrls, ActnMenus, PropSaveMain;

type
  TMain = class(TForm)
    ActionMng: TActionManager;
    actDel: TAction;
    actAdd: TAction;
    actEdit: TAction;
    ImageList1: TImageList;
    actBold: TAction;
    actUnderline: TAction;
    actItalic: TAction;
    actBig: TAction;
    actColor: TAction;
    actLink1: TAction;
    actLink2: TAction;
    actRefresh: TAction;
    actUndo: TAction;
    actOpen: TAction;
    actSave: TAction;
    ActMainMenu: TActionMainMenuBar;
    sb: TStatusBar;
    OpenDlg: TOpenDialog;
    actSaveAs: TAction;
    SaveDlg: TSaveDialog;
    PropSaveFile1: TPropSaveFile;
    PropSaveMain1: TPropSaveMain;
    FontDlg: TFontDialog;
    actFont: TAction;
    actStep: TAction;
    Action1: TAction;
    Action2: TAction;
    actGenContent: TAction;
    actSetColor: TAction;
    actLink3: TAction;
    pLeft: TPanel;
    lbTopics: TListBox;
    ActionToolBar1: TActionToolBar;
    pClient: TPanel;
    Splitter2: TSplitter;
    mEdit: TMemo;
    tbTool: TActionToolBar;
    ScrollBox: TScrollBox;
    lTest: TFormatLabel;
    pColor: TPanel;
    btColClose: TSpeedButton;
    ColorBox: TColorBox;
    chColor: TCheckBox;
    Splitter1: TSplitter;
    actRecentFile: TAction;
    actExit: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure lbTopicsClick(Sender: TObject);
    procedure actAddExecute(Sender: TObject);
    procedure actEditExecute(Sender: TObject);
    procedure actDelExecute(Sender: TObject);
    procedure mEditChange(Sender: TObject);
    procedure actBoldExecute(Sender: TObject);
    procedure actUnderlineExecute(Sender: TObject);
    procedure actItalicExecute(Sender: TObject);
    procedure actBigExecute(Sender: TObject);
    procedure actColorExecute(Sender: TObject);
    procedure actLink1Execute(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure actUndoExecute(Sender: TObject);
    procedure actLink2Execute(Sender: TObject);
    procedure actUseExecute(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actSaveAsExecute(Sender: TObject);
    procedure DropFileDropFiles(Sender: TObject; X, Y: Integer);
    procedure actFontExecute(Sender: TObject);
    procedure PropSaveMain1ReadProperties(PSFile: TPropSaveFile;
      Key: String);
    procedure PropSaveMain1SaveProperties(PSFile: TPropSaveFile;
      Key: String);
    procedure actStepExecute(Sender: TObject);
    procedure actGenContentExecute(Sender: TObject);
    procedure actSetColorExecute(Sender: TObject);
    procedure btColCloseClick(Sender: TObject);
    procedure actLink3Execute(Sender: TObject);
    procedure actRecentFileExecute(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
  private
    { Private declarations }
    L: TStrings;
    fn, s: string;
    Edited: boolean;
    EditedTopic: string;
    procedure SaveFile;
    procedure ShowTopicsList;
    procedure ShowTopic;
    procedure SelectTopic(Name: string);
    procedure DeleteTopic;
    procedure SaveTopic(NewName: string);
    procedure ShowTest;
    procedure ProcEdit(frm1,frm2: string; Pos: integer);

  public
    { Public declarations }
    procedure LoadFile(FileName: string);
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

uses rdlg, rtool, rstring, f_files;

procedure TMain.FormCreate(Sender: TObject);
begin
  L:=TStringList.Create;
end;

procedure TMain.FormShow(Sender: TObject);
begin
;
end;

procedure TMain.FormActivate(Sender: TObject);
begin
  if ParamCount>0 then
    LoadFile(ParamStr(1));
end;

procedure TMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  actSave.Execute;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
;
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
  L.Free;
end;

procedure TMain.LoadFile(FileName: string);
var i: integer;
begin
  fn:=FileName;
  L.LoadFromFile(fn);
  ShowTopicsList;
  Edited:=false;
  EditedTopic:='';
  sb.SimpleText:=fn;
  i:=Files.lbFiles.Items.IndexOf(fn);
  if i=-1 then Files.lbFiles.Items.Insert(0,fn)
          else Files.lbFiles.Items.Move(i,0);
end;

procedure TMain.SaveFile;
begin
  if fn='' then actSaveAs.Execute
  else L.SaveToFile(fn);
end;

procedure TMain.ShowTopicsList;
var i: integer;
begin
  mEdit.Lines.Clear;
  lbTopics.Items.Clear;
  for i:=0 to L.Count-1 do
  begin
    s:=Trim(L[i]);
    if (copy(s,1,1)='[') and (copy(s,Length(s),1)=']') then
      lbTopics.Items.Add(copy(s,2,Length(s)-2));
  end;
end;

procedure TMain.ShowTopic;
var i,pos: integer;
begin
  pos:=mEdit.SelStart;
  if Edited then SaveTopic('');
  mEdit.Lines.Clear;
  if lbTopics.ItemIndex<0 then Exit;
  s:=lbTopics.Items[lbTopics.ItemIndex];
  if EditedTopic<>s then Pos:=0;
  EditedTopic:=s;
  i:=L.IndexOf('['+s+']');
  if i>=0 then
  repeat
    Inc(i);
    if i>=L.Count then Break;
    s:=Trim(L[i]);
    // next topic? = end of my topic
    if (copy(s,1,1)='[') and (copy(s,Length(s),1)=']') then Break;
    mEdit.Lines.Add(s);
  until i>=L.Count-1;
  ShowTest;
  Edited:=false;
  mEdit.SelStart:=Pos;
  mEdit.SelLength:=0;
end;

procedure TMain.SelectTopic(Name: string);
var i: integer;
begin
  i:=lbTopics.Items.IndexOf(Name);
  lbTopics.ItemIndex:=i;
  ShowTopic;
end;

procedure TMain.DeleteTopic;
var i: integer;
begin
  if EditedTopic='' then Exit;
  i:=L.IndexOf('['+EditedTopic+']');
  if i>=0 then
  repeat
    L.Delete(i);
    if i>=L.Count then Break;
    s:=Trim(L[i]);
    // next topic? = end of my topic
    if (copy(s,1,1)='[') and (copy(s,Length(s),1)=']') then Break;
  until false;
end;

procedure TMain.SaveTopic(NewName: string);
var i: integer;
begin
  if EditedTopic='' then Exit;
//  Beep;
  DeleteTopic;
  if NewName='' then NewName:=EditedTopic;
  L.Add('['+NewName+']');
  for i:=0 to mEdit.Lines.Count-1 do
  begin
    s:=Trim(mEdit.Lines[i]);
    //if s<>'' then
    L.Add(s);
  end;
  if s<>'' then L.Add('');
end;

procedure TMain.lbTopicsClick(Sender: TObject);
begin
  ShowTopic;
end;

procedure TMain.mEditChange(Sender: TObject);
begin
  Edited:=true;
end;

procedure TMain.actOpenExecute(Sender: TObject);
begin
  if OpenDlg.Execute then LoadFile(OpenDlg.FileName);
end;

procedure TMain.actSaveExecute(Sender: TObject);
begin
  ShowTopic;
  SaveFile;
end;

procedure TMain.actSaveAsExecute(Sender: TObject);
begin
  ShowTopic;
  if SaveDlg.Execute then
  begin
    fn:=SaveDlg.FileName;
    SaveFile;
    sb.SimpleText:=fn;
  end;
end;

procedure TMain.actAddExecute(Sender: TObject);
begin
  s:='';
  if InputStr('','Enter Topic Name:',s) and (s<>'') then
  begin
    lbTopics.Items.Add(s);
    SelectTopic(s);
  end;
end;

procedure TMain.actEditExecute(Sender: TObject);
var n: string;
begin
  if lbTopics.ItemIndex<0 then Exit;
  s:=lbTopics.Items[lbTopics.ItemIndex];
  if InputStr('','Enter Topic Name:',s) and (s<>'') then
  begin
    n:=s;
    SaveTopic(n);
    ShowTopicsList;
    SelectTopic(n);
  end;
end;

procedure TMain.actDelExecute(Sender: TObject);
var i: integer;
begin
  i:=lbTopics.ItemIndex;
  if i<0 then Exit;
  if DlgQ(sContinueQ)<>mrYes then Exit;
  DeleteTopic;
  ShowTopicsList;
  if i>=lbTopics.Items.Count then i:=lbTopics.Items.Count-1;
  if i>=0 then s:=lbTopics.Items[i]
          else s:='';
  SelectTopic(s);
end;

procedure TMain.ShowTest;
var i: integer;
    pline: string;
    T: TStrings;
begin
  T:=TStringList.Create;
  try
    pline:='';
    for i:=0 to mEdit.Lines.Count-1 do
    begin
      s:=Trim(mEdit.Lines[i]);
      if (copy(s,Length(s),1)='\') then
        pline:=pline+Trim(copy(s,1,Length(s)-1))+' '
      else
        begin
          T.Add(pline+s);
          pline:='';
        end;
    end;
    lTest.AutoSize:=false;
    lTest.CaptionStrings.Assign(T);
    lTest.AutoSize:=true;
  finally
    T.Free;
  end;  
end;

procedure TMain.ProcEdit(frm1,frm2: string; Pos: integer);
var i1,i2: integer;
begin
  i1:=mEdit.SelStart;
  i2:=mEdit.SelLength;
  if i2=0 then
  begin
    mEdit.Text:=copy(mEdit.Text,1,i1)
               +frm1+frm2
               +copy(mEdit.Text,i1+1,Length(mEdit.Text));
    if Pos=0 then Pos:=Length(frm1);
    mEdit.SelStart:=i1+Pos;
  end
  else
  begin
    if copy(mEdit.SelText,i2,1)=' ' then i2:=i2-1;
    mEdit.Text:=copy(mEdit.Text,1,i1)
               +frm1+copy(mEdit.Text,i1+1,i2)+frm2
               +copy(mEdit.Text,i1+i2+1,Length(mEdit.Text));
    if Pos=0 then Pos:=i2+Length(frm1)+Length(frm2);
    mEdit.SelStart:=i1+Pos;
  end;
  ShowTest;
end;

procedure TMain.actBoldExecute(Sender: TObject);
begin
  ProcEdit('<B>','</B>',0);
end;

procedure TMain.actUnderlineExecute(Sender: TObject);
begin
  ProcEdit('<U>','</U>',0);
end;

procedure TMain.actItalicExecute(Sender: TObject);
begin
  ProcEdit('<I>','</I>',0);
end;

procedure TMain.actBigExecute(Sender: TObject);
begin
  ProcEdit('<BIG>','</BIG>',0);
end;

procedure TMain.actColorExecute(Sender: TObject);
var s: string;
begin
  ProcEdit('<COLOR=>','</COLOR>',7);
  s:=ColorBox.Items[ColorBox.ItemIndex];
  if chColor.Checked then ProcEdit(s,'',Length(s)+1);
end;

procedure TMain.actLink1Execute(Sender: TObject);
begin
  ProcEdit('<A HREF=>','</A>',8);
end;

procedure TMain.actLink2Execute(Sender: TObject);
begin
  ProcEdit('<A NAME=Topic#Step>','</A>',8);
end;

procedure TMain.actLink3Execute(Sender: TObject);
begin
  ProcEdit('<A NAME=@Form.Component>','</A>',9);
end;

procedure TMain.actStepExecute(Sender: TObject);
begin
  ProcEdit('##','',1);
end;

procedure TMain.actRefreshExecute(Sender: TObject);
begin
  ShowTest;
end;

procedure TMain.actUndoExecute(Sender: TObject);
begin
  Edited:=false;
  ShowTopic;
end;

procedure TMain.actUseExecute(Sender: TObject);
begin
  ShowTopic;
end;

procedure TMain.DropFileDropFiles(Sender: TObject; X, Y: Integer);
begin
//  if DropFile.Count>0 then LoadFile(DropFile.Files[0]);
end;

procedure TMain.actFontExecute(Sender: TObject);
begin
  FontDlg.Font.Assign(mEdit.Font);
  if FontDlg.Execute then mEdit.Font.Assign(FontDlg.Font);
end;

procedure TMain.PropSaveMain1ReadProperties(PSFile: TPropSaveFile;
  Key: String);
begin
  PSFile.ReadFont('EditFont',mEdit.Font);
  ColorBox.Selected:=PSFile.ReadInteger('Main','Color',0);
  pColor.Visible:=PSFile.ReadBool('Main','ColorBar',pColor.Visible);
  s:=PSFile.ReadString('Main','FileName','');
  if s<>'' then LoadFile(s);
end;

procedure TMain.PropSaveMain1SaveProperties(PSFile: TPropSaveFile;
  Key: String);
begin
  PSFile.WriteFont('EditFont',mEdit.Font);
  PSFile.WriteString('Main','FileName',fn);
  PSFile.WriteInteger('Main','Color',ColorBox.Selected);
  PSFile.WriteBool('Main','ColorBar',pColor.Visible);
end;

procedure TMain.actGenContentExecute(Sender: TObject);
const sCont='Content';
var i: integer;
begin
  if DlgQ(sContinueQ)<>mrYes then Exit;
  SelectTopic(sCont);
  if lbTopics.ItemIndex=-1 then
  begin
    lbTopics.Items.Add(sCont);
    SelectTopic(sCont);
  end;
  mEdit.Lines.Clear;
  mEdit.Lines.Add('<B>'+sCont+'</B>');
  mEdit.Lines.Add('');
  for i:=0 to lbTopics.Items.Count-1 do
  begin
    s:=lbTopics.Items[i];
    if s=sCont then Continue;
    mEdit.Lines.Add(Format('<A NAME=%s>%s</A>',[s,s]));
  end;
  SaveTopic('');
  ShowTest;
end;

procedure TMain.actSetColorExecute(Sender: TObject);
begin
  pColor.Visible:=true;
end;

procedure TMain.btColCloseClick(Sender: TObject);
begin
  pColor.Visible:=false;
end;

procedure TMain.actRecentFileExecute(Sender: TObject);
begin
  Files.ShowModal;
end;

procedure TMain.actExitExecute(Sender: TObject);
begin
  Close;
end;

end.
