unit ApplicationHook;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs;

type

  TOnHookMessage = procedure (Sender : TObject;
                              var Message : TMessage;
                              var Handled : boolean)
                              of object;

  TApplicationHook = class(TComponent)
  private
    FHook : TWindowHook;
    FOnMessage : TOnHookMessage;
  protected
    function HookProc(var Message : TMessage) : boolean;
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    procedure Activate;
    procedure Deactivate;
  published
    property OnMessage : TOnHookMessage
      read FOnMessage write FOnMessage;
  end;

procedure Register;

implementation

{$R *.res}

procedure Register;
begin
  RegisterComponents('Rosi', [TApplicationHook]);
end;

{ TpsvApplicationHook }

constructor TApplicationHook.Create(AOwner: TComponent);
begin
  inherited;
  FHook := HookProc;
end;

destructor TApplicationHook.Destroy;
begin
  if (not (csDesigning in ComponentState) ) then Deactivate;
  inherited;
end;

function TApplicationHook.HookProc(var Message: TMessage): boolean;
begin
  Result := false;
  if Assigned(FOnMessage) then
     FOnMessage(Self, Message, Result);
end;

procedure TApplicationHook.Activate;
begin
  if Assigned(Application) then Application.HookMainWindow(FHook);
end;

procedure TApplicationHook.Deactivate;
begin
  if Assigned(Application) then Application.UnHookMainWindow(FHook);
end;

end.
